% CIS601 - Tom Gradel - Homework 8

% Clean up any old figures
close all;

% Number of images
IFIGURE = 2;
im = cell(IFIGURE,2); % Cell array for images

ICLUSTER = 10;

% Images are roughly the same sime, but trim images to this size
IROW = 160;
ICOL = 230;

% File names for textures
im{1,1} = 'rose.bmp';
im{2,1} = 'house.bmp';

% load the images
figure;
for x=1:IFIGURE
    I = imread(im{x,1});
    I = I([1:IROW],[1:ICOL],:);
    subplot(2,2,x*2-1); imshow(I); title(['Original: ', im{x,1}]);
    [X,map] = rgb2ind(I,256);
    C = [reshape(I,IROW*ICOL,3),X(:)] ; % X1,X2,X2,Y) = (R,G,B,index)
    idx = kmeans(double(C),ICLUSTER);
    C = C(:,[1:3]);
    for j=1:ICLUSTER
        n = find(idx==j);
        cluster=C(n,:);
        avg = uint8(0.5+mean(cluster));
        M = repmat(avg,length(n),1);
        C(n,:) = M;
    end
    II = reshape(C, IROW, ICOL, 3);
    subplot(2,2,x*2); imshow(II); title(['Cluster: ', im{x,1}]);
end 

